import * as i2 from '@dynamic-forms/core/input-mask';
import { DynamicFormInputMaskDatetimeFormatter, dynamicFormInputMaskNumberConverter, withDynamicFormInputMaskConverter, DynamicFormInputMaskBase, DynamicFormInputMaskDirective, DynamicFormInputMaskControl, withDynamicFormInputMaskConverterService } from '@dynamic-forms/core/input-mask';
import * as i1 from '@dynamic-forms/material';
import { matDynamicFormLibrary } from '@dynamic-forms/material';
import * as i0 from '@angular/core';
import { Injectable, Component, ViewChild, NgModule } from '@angular/core';
import * as i1$1 from '@dynamic-forms/core';
import { DynamicFormDateConverter, DynamicFormElementComponent, mergeDynamicFormsFeatures, withDynamicFormInputs, importDynamicFormsProviders } from '@dynamic-forms/core';
import { JsonPipe } from '@angular/common';
import * as i2$1 from '@angular/forms';
import { NgControl, ReactiveFormsModule } from '@angular/forms';
import * as i4 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i3 from '@angular/material/input';
import { MatInput, MatInputModule } from '@angular/material/input';

class MatDynamicFormInputMaskDatetimeConverter extends DynamicFormDateConverter {
    constructor(datetimeAdapter, datetimeFormatter) {
        super();
        this.datetimeAdapter = datetimeAdapter;
        this.datetimeFormatter = datetimeFormatter;
    }
    isDateInstance(value) {
        return this.datetimeAdapter.isDateInstance(value);
    }
    isValid(value) {
        return this.datetimeAdapter.isValid(value);
    }
    compare(first, second) {
        return this.datetimeAdapter.compareDate(first, second);
    }
    parseDate(value, options) {
        return this.datetimeAdapter.parse(value, options);
    }
    formatDate(date, options) {
        const datetimeParts = {
            year: this.datetimeAdapter.getYear(date),
            month: this.datetimeAdapter.getMonth(date),
            date: this.datetimeAdapter.getDate(date),
            hours: this.datetimeAdapter.getHours(date),
            minutes: this.datetimeAdapter.getMinutes(date),
            seconds: this.datetimeAdapter.getSeconds(date),
        };
        return this.datetimeFormatter.format(datetimeParts, options);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskDatetimeConverter, deps: [{ token: i1.DatetimeAdapter }, { token: i2.DynamicFormInputMaskDatetimeFormatter }], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskDatetimeConverter }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskDatetimeConverter, decorators: [{
            type: Injectable
        }], ctorParameters: () => [{ type: i1.DatetimeAdapter }, { type: i2.DynamicFormInputMaskDatetimeFormatter }] });

const matDynamicFormInputMaskDatetimeConverter = {
    type: 'datetime',
    aliases: ['datetime'],
    converter: MatDynamicFormInputMaskDatetimeConverter,
    deps: [DynamicFormInputMaskDatetimeFormatter],
    libraryName: matDynamicFormLibrary.name,
};
const matDynamicFormInputMaskConverters = [dynamicFormInputMaskNumberConverter, matDynamicFormInputMaskDatetimeConverter];
function withMatDynamicFormInputMaskConverters() {
    return withDynamicFormInputMaskConverter(...matDynamicFormInputMaskConverters);
}

class MatDynamicFormInputMaskComponent extends DynamicFormInputMaskBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    ngOnInit() {
        this._matInput.ngControl = this._ngControl;
        this._matInput['_errorStateTracker'].ngControl = this._ngControl;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormInputMaskComponent, isStandalone: true, selector: "mat-dynamic-form-input-mask", viewQueries: [{ propertyName: "_matInput", first: true, predicate: MatInput, descendants: true, static: true }, { propertyName: "_ngControl", first: true, predicate: NgControl, descendants: true, static: true }], usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input matInput [dynamicFormInputMask]=\"inputMask\" [id]=\"inputId\" [placeholder]=\"input.placeholder\" [formControl]=\"control\" />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: DynamicFormInputMaskDirective, selector: "[dynamicFormInputMask]", inputs: ["dynamicFormInputMask"], exportAs: ["dynamicFormInputMask"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i3.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i4.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i4.MatLabel, selector: "mat-label" }, { kind: "directive", type: i4.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i4.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i4.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i4.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatFormFieldModule }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-input-mask', imports: [JsonPipe, ReactiveFormsModule, DynamicFormInputMaskDirective, DynamicFormElementComponent, MatInputModule, MatFormFieldModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input matInput [dynamicFormInputMask]=\"inputMask\" [id]=\"inputId\" [placeholder]=\"input.placeholder\" [formControl]=\"control\" />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }], propDecorators: { _matInput: [{
                type: ViewChild,
                args: [MatInput, { static: true }]
            }], _ngControl: [{
                type: ViewChild,
                args: [NgControl, { static: true }]
            }] } });

const matDynamicFormInputMaskType = {
    type: 'input-mask',
    component: MatDynamicFormInputMaskComponent,
    control: DynamicFormInputMaskControl,
    libraryName: matDynamicFormLibrary.name,
};
function withMatDynamicFormInputMask() {
    return mergeDynamicFormsFeatures(withDynamicFormInputs(matDynamicFormInputMaskType), withDynamicFormInputMaskConverterService());
}
/**
 * @deprecated Use {@link withMatDynamicFormInputMask} instead.
 */
class MatDynamicFormInputMaskModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskModule }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskModule, providers: importDynamicFormsProviders(withMatDynamicFormInputMask()) }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputMaskModule, decorators: [{
            type: NgModule,
            args: [{ providers: importDynamicFormsProviders(withMatDynamicFormInputMask()) }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { MatDynamicFormInputMaskComponent, MatDynamicFormInputMaskDatetimeConverter, MatDynamicFormInputMaskModule, matDynamicFormInputMaskConverters, matDynamicFormInputMaskDatetimeConverter, matDynamicFormInputMaskType, withMatDynamicFormInputMask, withMatDynamicFormInputMaskConverters };
//# sourceMappingURL=dynamic-forms-material-input-mask.mjs.map
