import * as i0 from '@angular/core';
import { EventEmitter, Component, Optional, Inject, ViewChild, Input, Output, NgModule, Injectable } from '@angular/core';
import * as i1$1 from '@dynamic-forms/core';
import { DYNAMIC_FORM_THEME, DynamicFormElementsComponent, DynamicFormButtonBase, DynamicFormColorPipe, DynamicFormIconBase, DynamicFormIconPipe, withDynamicFormActions, DynamicFormActionModule, DynamicFormConfigModule, importDynamicFormsProviders, DynamicFormAccordionBase, dynamicFormItemsFactory, withDynamicFormElements, DynamicFormTabsBase, DynamicFormModalBase, DynamicFormElementComponent, dynamicFormModalFactory, DynamicFormModalModule, withDynamicFormModalActionHandlers, DynamicFormInputBase, DynamicFormFileBase, DynamicFormFileDirective, withDynamicFormInputs, withDynamicFormTextboxActionHandlers, withDynamicFormFileValidators, DynamicFormFileModule, DynamicFormTextboxModule, provideDynamicForms, withDynamicFormValidationDefaults, withDynamicFormsTheme, withDynamicFormsIdBuilder, provideDynamicFormsWithDefaultFeatures, withDynamicFormsLibrary, DynamicFormsModule, withDynamicFormValidation } from '@dynamic-forms/core';
import { NgClass, AsyncPipe } from '@angular/common';
import * as i2 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i1 from '@angular/material/dialog';
import { MatDialogConfig, MatDialogModule } from '@angular/material/dialog';
import * as i3 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i4 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i1$2 from '@angular/material/expansion';
import { MatExpansionModule } from '@angular/material/expansion';
import * as i1$3 from '@angular/material/tabs';
import { MatTabsModule } from '@angular/material/tabs';
import * as i3$2 from '@angular/material/form-field';
import { MatFormFieldModule, MAT_FORM_FIELD_DEFAULT_OPTIONS } from '@angular/material/form-field';
import * as i2$1 from '@angular/forms';
import { ReactiveFormsModule, NgControl } from '@angular/forms';
import * as i3$1 from '@angular/material/checkbox';
import { MatCheckboxModule } from '@angular/material/checkbox';
import * as i5 from '@angular/material/autocomplete';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import * as i4$1 from '@angular/material/input';
import { MatInputModule, MatInput } from '@angular/material/input';
import { startWith, map } from 'rxjs/operators';
import * as i5$1 from '@angular/material/core';
import { DateAdapter, NativeDateAdapter } from '@angular/material/core';
import * as i5$2 from '@angular/material/datepicker';
import { MatDatepickerModule } from '@angular/material/datepicker';
import * as i3$3 from '@angular/material/radio';
import { MatRadioModule } from '@angular/material/radio';
import * as i4$2 from '@angular/material/select';
import { MatSelectModule } from '@angular/material/select';
import * as i3$4 from '@angular/material/slide-toggle';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import * as i5$3 from '@angular/cdk/text-field';
import * as i3$5 from '@angular/material/button-toggle';
import { MatButtonToggleModule } from '@angular/material/button-toggle';

const matDynamicFormLibrary = {
    name: 'material',
    references: ['core'],
};

class MatDynamicFormDialogComponent {
    constructor(dialog, theme) {
        this.dialog = dialog;
        this.theme = theme;
        // eslint-disable-next-line
        this.escaped = new EventEmitter();
    }
    ngOnChanges(changes) {
        if (this._dialog && changes.maximized) {
            const width = this.getDialogWidth();
            const height = this.getDialogHeight();
            this._dialog.reference.updateSize(width, height);
        }
    }
    ngOnInit() {
        this._dialogOpenSubscription = this.isOpen$.subscribe(isOpen => (isOpen ? this.openDialog() : this.closeDialog()));
    }
    ngOnDestroy() {
        this._dialogOpenSubscription.unsubscribe();
        this.closeDialog();
    }
    openDialog() {
        this.closeDialog();
        const config = this.getDialogConfig();
        const reference = this.dialog.open(this.dialogTemplateRef, config);
        const subscription = reference.beforeClosed().subscribe(_ => this.escaped.emit());
        this._dialog = { config, reference, subscription };
    }
    closeDialog() {
        if (this._dialog) {
            this._dialog.reference.close();
            this._dialog.subscription.unsubscribe();
            this._dialog = null;
        }
    }
    getDialogWidth() {
        return this.maximized ? this.maxWidth || '100%' : this.width;
    }
    getDialogHeight() {
        return this.maximized ? this.maxHeight || '100%' : this.height;
    }
    getDialogConfig() {
        const config = new MatDialogConfig();
        config.width = this.getDialogWidth();
        config.height = this.getDialogHeight();
        config.minWidth = this.minWidth;
        config.minHeight = this.minHeight;
        config.maxWidth = this.maxWidth;
        config.maxHeight = this.maxHeight;
        return config;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormDialogComponent, deps: [{ token: i1.MatDialog }, { token: DYNAMIC_FORM_THEME, optional: true }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormDialogComponent, isStandalone: true, selector: "mat-dynamic-form-dialog", inputs: { isOpen$: "isOpen$", children: "children", headerActions: "headerActions", footerActions: "footerActions", width: "width", height: "height", minWidth: "minWidth", minHeight: "minHeight", maxWidth: "maxWidth", maxHeight: "maxHeight", maximized: "maximized", title: "title", titleHtml: "titleHtml", classNameForm: "classNameForm", classNameModal: "classNameModal", classNameChildren: "classNameChildren", classNameHeader: "classNameHeader", classNameFooter: "classNameFooter", classNameTitle: "classNameTitle" }, outputs: { escaped: "escaped" }, viewQueries: [{ propertyName: "dialogTemplateRef", first: true, predicate: ["dialogTemplateRef"], descendants: true, static: true }], usesOnChanges: true, ngImport: i0, template: "<ng-template #dialogTemplateRef>\n  <div class=\"dynamic-form-wrapper\" [ngClass]=\"theme\" [class.maximized]=\"maximized\">\n    <div class=\"dynamic-form\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n      <div class=\"dynamic-form-modal\" [ngClass]=\"classNameModal\" [class.maximized]=\"maximized\">\n        @if (title || titleHtml || headerActions?.length) {\n          <div class=\"modal-header\" [ngClass]=\"classNameHeader\">\n            @if (titleHtml) {\n              <div class=\"modal-title\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n            } @else {\n              <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n            }\n            @if (headerActions?.length) {\n              <div class=\"modal-toolbar\">\n                <dynamic-form-elements [elements]=\"headerActions\" />\n              </div>\n            }\n          </div>\n        }\n        <mat-dialog-content class=\"modal-body\" [ngClass]=\"classNameChildren\" [class.maximized]=\"maximized\">\n          <dynamic-form-elements [elements]=\"children\" />\n        </mat-dialog-content>\n        @if (footerActions?.length) {\n          <mat-dialog-actions class=\"modal-footer\" [ngClass]=\"classNameFooter\">\n            <dynamic-form-elements [elements]=\"footerActions\" />\n          </mat-dialog-actions>\n        }\n      </div>\n    </div>\n  </div>\n</ng-template>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: MatDialogModule }, { kind: "directive", type: i1.MatDialogActions, selector: "[mat-dialog-actions], mat-dialog-actions, [matDialogActions]", inputs: ["align"] }, { kind: "directive", type: i1.MatDialogContent, selector: "[mat-dialog-content], mat-dialog-content, [matDialogContent]" }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormDialogComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-dialog', imports: [NgClass, MatDialogModule, DynamicFormElementsComponent], template: "<ng-template #dialogTemplateRef>\n  <div class=\"dynamic-form-wrapper\" [ngClass]=\"theme\" [class.maximized]=\"maximized\">\n    <div class=\"dynamic-form\" [ngClass]=\"classNameForm\" [class.maximized]=\"maximized\">\n      <div class=\"dynamic-form-modal\" [ngClass]=\"classNameModal\" [class.maximized]=\"maximized\">\n        @if (title || titleHtml || headerActions?.length) {\n          <div class=\"modal-header\" [ngClass]=\"classNameHeader\">\n            @if (titleHtml) {\n              <div class=\"modal-title\" [ngClass]=\"classNameTitle\" [innerHTML]=\"titleHtml\"></div>\n            } @else {\n              <div class=\"modal-title\" [ngClass]=\"classNameTitle\">{{ title }}</div>\n            }\n            @if (headerActions?.length) {\n              <div class=\"modal-toolbar\">\n                <dynamic-form-elements [elements]=\"headerActions\" />\n              </div>\n            }\n          </div>\n        }\n        <mat-dialog-content class=\"modal-body\" [ngClass]=\"classNameChildren\" [class.maximized]=\"maximized\">\n          <dynamic-form-elements [elements]=\"children\" />\n        </mat-dialog-content>\n        @if (footerActions?.length) {\n          <mat-dialog-actions class=\"modal-footer\" [ngClass]=\"classNameFooter\">\n            <dynamic-form-elements [elements]=\"footerActions\" />\n          </mat-dialog-actions>\n        }\n      </div>\n    </div>\n  </div>\n</ng-template>\n" }]
        }], ctorParameters: () => [{ type: i1.MatDialog }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [DYNAMIC_FORM_THEME]
                }] }], propDecorators: { dialogTemplateRef: [{
                type: ViewChild,
                args: ['dialogTemplateRef', { static: true }]
            }], isOpen$: [{
                type: Input
            }], children: [{
                type: Input
            }], headerActions: [{
                type: Input
            }], footerActions: [{
                type: Input
            }], width: [{
                type: Input
            }], height: [{
                type: Input
            }], minWidth: [{
                type: Input
            }], minHeight: [{
                type: Input
            }], maxWidth: [{
                type: Input
            }], maxHeight: [{
                type: Input
            }], maximized: [{
                type: Input
            }], title: [{
                type: Input
            }], titleHtml: [{
                type: Input
            }], classNameForm: [{
                type: Input
            }], classNameModal: [{
                type: Input
            }], classNameChildren: [{
                type: Input
            }], classNameHeader: [{
                type: Input
            }], classNameFooter: [{
                type: Input
            }], classNameTitle: [{
                type: Input
            }], escaped: [{
                type: Output
            }] } });

class MatDynamicFormButtonComponent extends DynamicFormButtonBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormButtonComponent, deps: [{ token: i1$1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormButtonComponent, isStandalone: true, selector: "mat-dynamic-form-button", usesInheritance: true, ngImport: i0, template: "@if (template.url) {\n  <a\n    mat-flat-button\n    class=\"dynamic-form-button\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor: 'primary'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    [href]=\"template.url\"\n    [target]=\"template.urlTarget || '_blank'\"\n    >{{ template.label }}</a\n  >\n} @else {\n  <button\n    mat-flat-button\n    class=\"dynamic-form-button\"\n    [id]=\"id\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor: 'primary'\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    (click)=\"onClick($event)\"\n    >{{ template.label }}</button\n  >\n}\n@if (dialog) {\n  <mat-dynamic-form-dialog\n    [isOpen$]=\"dialogOpen$\"\n    [children]=\"dialogChildren\"\n    [headerActions]=\"dialogHeaderActions\"\n    [footerActions]=\"dialogFooterActions\"\n    [width]=\"template.dialogWidth\"\n    [minWidth]=\"template.dialogMinWidth\"\n    [maxWidth]=\"template.dialogMaxWidth\"\n    [title]=\"template.dialogTitle\"\n    [titleHtml]=\"template.dialogTitleHtml\"\n    [classNameForm]=\"element.root.template.className\"\n    [classNameModal]=\"template.className\"\n    [classNameTitle]=\"template.classNameDialogTitle\"\n    [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n    [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n    [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n    (escaped)=\"closeDialog()\"\n  />\n}\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "pipe", type: DynamicFormColorPipe, name: "dynamicFormColor" }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i2.MatAnchor, selector: "a[mat-button], a[mat-raised-button], a[mat-flat-button], a[mat-stroked-button]", exportAs: ["matButton", "matAnchor"] }, { kind: "component", type: i2.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormButtonComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-button', imports: [NgClass, DynamicFormColorPipe, MatDynamicFormDialogComponent, MatButtonModule], template: "@if (template.url) {\n  <a\n    mat-flat-button\n    class=\"dynamic-form-button\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor: 'primary'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    [href]=\"template.url\"\n    [target]=\"template.urlTarget || '_blank'\"\n    >{{ template.label }}</a\n  >\n} @else {\n  <button\n    mat-flat-button\n    class=\"dynamic-form-button\"\n    [id]=\"id\"\n    [ngClass]=\"template.className\"\n    [color]=\"template.color | dynamicFormColor: 'primary'\"\n    [type]=\"template.type || 'button'\"\n    [disabled]=\"template.disabled\"\n    [hidden]=\"template.hidden\"\n    (click)=\"onClick($event)\"\n    >{{ template.label }}</button\n  >\n}\n@if (dialog) {\n  <mat-dynamic-form-dialog\n    [isOpen$]=\"dialogOpen$\"\n    [children]=\"dialogChildren\"\n    [headerActions]=\"dialogHeaderActions\"\n    [footerActions]=\"dialogFooterActions\"\n    [width]=\"template.dialogWidth\"\n    [minWidth]=\"template.dialogMinWidth\"\n    [maxWidth]=\"template.dialogMaxWidth\"\n    [title]=\"template.dialogTitle\"\n    [titleHtml]=\"template.dialogTitleHtml\"\n    [classNameForm]=\"element.root.template.className\"\n    [classNameModal]=\"template.className\"\n    [classNameTitle]=\"template.classNameDialogTitle\"\n    [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n    [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n    [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n    (escaped)=\"closeDialog()\"\n  />\n}\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormActionService }] });

const matDynamicFormButtonType = {
    type: 'button',
    component: MatDynamicFormButtonComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormIconComponent extends DynamicFormIconBase {
    constructor(actionService) {
        super(actionService);
        this.actionService = actionService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormIconComponent, deps: [{ token: i1$1.DynamicFormActionService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormIconComponent, isStandalone: true, selector: "mat-dynamic-form-icon", usesInheritance: true, ngImport: i0, template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  @if (template.url) {\n    <a\n      mat-icon-button\n      class=\"dynamic-form-icon\"\n      [ngClass]=\"template.className\"\n      [color]=\"template.color | dynamicFormColor: 'primary'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      [matTooltip]=\"template.label\"\n      [href]=\"template.url\"\n      [target]=\"template.urlTarget || '_blank'\"\n    >\n      <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon></a\n    >\n  } @else {\n    <button\n      mat-icon-button\n      class=\"dynamic-form-icon\"\n      [id]=\"id\"\n      [ngClass]=\"template.className\"\n      [color]=\"template.color | dynamicFormColor: 'primary'\"\n      [type]=\"template.type || 'button'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      [matTooltip]=\"template.label\"\n      (click)=\"onClick($event)\"\n    >\n      <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon>\n    </button>\n  }\n</div>\n@if (dialog) {\n  <mat-dynamic-form-dialog\n    [isOpen$]=\"dialogOpen$\"\n    [children]=\"dialogChildren\"\n    [headerActions]=\"dialogHeaderActions\"\n    [footerActions]=\"dialogFooterActions\"\n    [width]=\"template.dialogWidth\"\n    [minWidth]=\"template.dialogMinWidth\"\n    [maxWidth]=\"template.dialogMaxWidth\"\n    [title]=\"template.dialogTitle\"\n    [titleHtml]=\"template.dialogTitleHtml\"\n    [classNameForm]=\"element.root.template.className\"\n    [classNameModal]=\"template.className\"\n    [classNameTitle]=\"template.classNameDialogTitle\"\n    [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n    [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n    [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n    (escaped)=\"closeDialog()\"\n  />\n}\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "pipe", type: DynamicFormColorPipe, name: "dynamicFormColor" }, { kind: "pipe", type: DynamicFormIconPipe, name: "dynamicFormIcon" }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i2.MatIconAnchor, selector: "a[mat-icon-button]", exportAs: ["matButton", "matAnchor"] }, { kind: "component", type: i2.MatIconButton, selector: "button[mat-icon-button]", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i3.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i4.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormIconComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-icon', imports: [
                        NgClass,
                        DynamicFormColorPipe,
                        DynamicFormIconPipe,
                        MatDynamicFormDialogComponent,
                        MatButtonModule,
                        MatIconModule,
                        MatTooltipModule,
                    ], template: "<div class=\"dynamic-form-icon-wrapper\" [ngClass]=\"template.classNameWrapper\">\n  @if (template.url) {\n    <a\n      mat-icon-button\n      class=\"dynamic-form-icon\"\n      [ngClass]=\"template.className\"\n      [color]=\"template.color | dynamicFormColor: 'primary'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      [matTooltip]=\"template.label\"\n      [href]=\"template.url\"\n      [target]=\"template.urlTarget || '_blank'\"\n    >\n      <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon></a\n    >\n  } @else {\n    <button\n      mat-icon-button\n      class=\"dynamic-form-icon\"\n      [id]=\"id\"\n      [ngClass]=\"template.className\"\n      [color]=\"template.color | dynamicFormColor: 'primary'\"\n      [type]=\"template.type || 'button'\"\n      [disabled]=\"template.disabled\"\n      [hidden]=\"template.hidden\"\n      [matTooltip]=\"template.label\"\n      (click)=\"onClick($event)\"\n    >\n      <mat-icon>{{ template.icon | dynamicFormIcon }}</mat-icon>\n    </button>\n  }\n</div>\n@if (dialog) {\n  <mat-dynamic-form-dialog\n    [isOpen$]=\"dialogOpen$\"\n    [children]=\"dialogChildren\"\n    [headerActions]=\"dialogHeaderActions\"\n    [footerActions]=\"dialogFooterActions\"\n    [width]=\"template.dialogWidth\"\n    [minWidth]=\"template.dialogMinWidth\"\n    [maxWidth]=\"template.dialogMaxWidth\"\n    [title]=\"template.dialogTitle\"\n    [titleHtml]=\"template.dialogTitleHtml\"\n    [classNameForm]=\"element.root.template.className\"\n    [classNameModal]=\"template.className\"\n    [classNameTitle]=\"template.classNameDialogTitle\"\n    [classNameChildren]=\"dialogTemplate?.classNameChildren\"\n    [classNameHeader]=\"dialogTemplate?.classNameHeader\"\n    [classNameFooter]=\"dialogTemplate?.classNameFooter\"\n    (escaped)=\"closeDialog()\"\n  />\n}\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormActionService }] });

const matDynamicFormIconType = {
    type: 'icon',
    component: MatDynamicFormIconComponent,
    libraryName: matDynamicFormLibrary.name,
};

const matDynamicFormActionTypes = [matDynamicFormButtonType, matDynamicFormIconType];
function withMatDynamicFormActionDefaultFeatures() {
    return [withDynamicFormActions(...matDynamicFormActionTypes)];
}
const modules$6 = [DynamicFormActionModule, DynamicFormConfigModule];
/**
 * @deprecated Use {@link withMatDynamicFormActionDefaultFeatures} instead.
 */
class MatDynamicFormActionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormActionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormActionModule, imports: [DynamicFormActionModule, DynamicFormConfigModule], exports: [DynamicFormActionModule, DynamicFormConfigModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormActionModule, providers: importDynamicFormsProviders(...withMatDynamicFormActionDefaultFeatures()), imports: [modules$6, DynamicFormActionModule, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormActionModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$6,
                    exports: modules$6,
                    providers: importDynamicFormsProviders(...withMatDynamicFormActionDefaultFeatures()),
                }]
        }] });

class MatDynamicFormAccordionComponent extends DynamicFormAccordionBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormAccordionComponent, isStandalone: true, selector: "mat-dynamic-form-accordion", usesInheritance: true, ngImport: i0, template: "<mat-accordion class=\"dynamic-form-items dynamic-form-accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  @for (child of element.children; let index = $index; track index) {\n    <mat-expansion-panel\n      [ngClass]=\"child.template.className\"\n      [expanded]=\"index === selectedIndex\"\n      [disabled]=\"child.disabled\"\n      [hidden]=\"child.template.hidden\"\n      (opened)=\"openItem(index)\"\n      (closed)=\"closeItem(index)\"\n    >\n      <mat-expansion-panel-header class=\"dynamic-form-item-header\">\n        <mat-panel-title>{{ child.label }}</mat-panel-title>\n      </mat-expansion-panel-header>\n      <ng-template matExpansionPanelContent>\n        <div class=\"dynamic-form-item\">\n          <dynamic-form-elements [elements]=\"child.children\" />\n        </div>\n      </ng-template>\n    </mat-expansion-panel>\n  }\n</mat-accordion>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: MatExpansionModule }, { kind: "directive", type: i1$2.MatAccordion, selector: "mat-accordion", inputs: ["hideToggle", "displayMode", "togglePosition"], exportAs: ["matAccordion"] }, { kind: "component", type: i1$2.MatExpansionPanel, selector: "mat-expansion-panel", inputs: ["hideToggle", "togglePosition"], outputs: ["afterExpand", "afterCollapse"], exportAs: ["matExpansionPanel"] }, { kind: "component", type: i1$2.MatExpansionPanelHeader, selector: "mat-expansion-panel-header", inputs: ["expandedHeight", "collapsedHeight", "tabIndex"] }, { kind: "directive", type: i1$2.MatExpansionPanelTitle, selector: "mat-panel-title" }, { kind: "directive", type: i1$2.MatExpansionPanelContent, selector: "ng-template[matExpansionPanelContent]" }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-accordion', imports: [NgClass, MatExpansionModule, DynamicFormElementsComponent], template: "<mat-accordion class=\"dynamic-form-items dynamic-form-accordion\" [ngClass]=\"template.className\" [hidden]=\"template.hidden\">\n  @for (child of element.children; let index = $index; track index) {\n    <mat-expansion-panel\n      [ngClass]=\"child.template.className\"\n      [expanded]=\"index === selectedIndex\"\n      [disabled]=\"child.disabled\"\n      [hidden]=\"child.template.hidden\"\n      (opened)=\"openItem(index)\"\n      (closed)=\"closeItem(index)\"\n    >\n      <mat-expansion-panel-header class=\"dynamic-form-item-header\">\n        <mat-panel-title>{{ child.label }}</mat-panel-title>\n      </mat-expansion-panel-header>\n      <ng-template matExpansionPanelContent>\n        <div class=\"dynamic-form-item\">\n          <dynamic-form-elements [elements]=\"child.children\" />\n        </div>\n      </ng-template>\n    </mat-expansion-panel>\n  }\n</mat-accordion>\n" }]
        }], ctorParameters: () => [] });

const matDynamicFormAccordionType = {
    type: 'accordion',
    factory: dynamicFormItemsFactory,
    component: MatDynamicFormAccordionComponent,
    libraryName: matDynamicFormLibrary.name,
};
const modules$5 = [DynamicFormConfigModule];
/**
 * @deprecated Use {@link withMatDynamicFormElementDefaultFeatures} instead.
 */
class MatDynamicFormAccordionModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionModule, imports: [DynamicFormConfigModule], exports: [DynamicFormConfigModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionModule, providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormAccordionType)), imports: [modules$5, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormAccordionModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$5,
                    exports: modules$5,
                    providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormAccordionType)),
                }]
        }] });

class MatDynamicFormTabsComponent extends DynamicFormTabsBase {
    constructor() {
        super();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormTabsComponent, isStandalone: true, selector: "mat-dynamic-form-tabs", usesInheritance: true, ngImport: i0, template: "<mat-tab-group\n  class=\"dynamic-form-items dynamic-form-tabs\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [selectedIndex]=\"selectedIndex\"\n  (selectedIndexChange)=\"selectItem($event)\"\n>\n  @for (child of element.children; track $index) {\n    <mat-tab [ngClass]=\"child.template.className\" [disabled]=\"child.disabled\" [hidden]=\"template.hidden\">\n      <ng-template matTabLabel>\n        <div class=\"dynamic-form-item-header\">{{ child.label }}</div>\n      </ng-template>\n      <ng-template matTabContent>\n        <div class=\"dynamic-form-item\">\n          <dynamic-form-elements [elements]=\"child.children\" />\n        </div>\n      </ng-template>\n    </mat-tab>\n  }\n</mat-tab-group>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "ngmodule", type: MatTabsModule }, { kind: "directive", type: i1$3.MatTabContent, selector: "[matTabContent]" }, { kind: "directive", type: i1$3.MatTabLabel, selector: "[mat-tab-label], [matTabLabel]" }, { kind: "component", type: i1$3.MatTab, selector: "mat-tab", inputs: ["disabled", "label", "aria-label", "aria-labelledby", "labelClass", "bodyClass"], exportAs: ["matTab"] }, { kind: "component", type: i1$3.MatTabGroup, selector: "mat-tab-group", inputs: ["color", "fitInkBarToContent", "mat-stretch-tabs", "dynamicHeight", "selectedIndex", "headerPosition", "animationDuration", "contentTabIndex", "disablePagination", "disableRipple", "preserveContent", "backgroundColor", "aria-label", "aria-labelledby"], outputs: ["selectedIndexChange", "focusChange", "animationDone", "selectedTabChange"], exportAs: ["matTabGroup"] }, { kind: "component", type: DynamicFormElementsComponent, selector: "dynamic-form-elements", inputs: ["elements"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-tabs', imports: [NgClass, MatTabsModule, DynamicFormElementsComponent], template: "<mat-tab-group\n  class=\"dynamic-form-items dynamic-form-tabs\"\n  [ngClass]=\"template.className\"\n  [hidden]=\"template.hidden\"\n  [selectedIndex]=\"selectedIndex\"\n  (selectedIndexChange)=\"selectItem($event)\"\n>\n  @for (child of element.children; track $index) {\n    <mat-tab [ngClass]=\"child.template.className\" [disabled]=\"child.disabled\" [hidden]=\"template.hidden\">\n      <ng-template matTabLabel>\n        <div class=\"dynamic-form-item-header\">{{ child.label }}</div>\n      </ng-template>\n      <ng-template matTabContent>\n        <div class=\"dynamic-form-item\">\n          <dynamic-form-elements [elements]=\"child.children\" />\n        </div>\n      </ng-template>\n    </mat-tab>\n  }\n</mat-tab-group>\n" }]
        }], ctorParameters: () => [] });

const matDynamicFormTabsType = {
    type: 'tabs',
    factory: dynamicFormItemsFactory,
    component: MatDynamicFormTabsComponent,
    libraryName: matDynamicFormLibrary.name,
};
const modules$4 = [DynamicFormConfigModule];
/**
 * @deprecated Use {@link withMatDynamicFormElementDefaultFeatures} instead.
 */
class MatDynamicFormTabsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsModule, imports: [DynamicFormConfigModule], exports: [DynamicFormConfigModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsModule, providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormTabsType)), imports: [modules$4, DynamicFormConfigModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTabsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$4,
                    exports: modules$4,
                    providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormTabsType)),
                }]
        }] });

const modules$3 = [MatDynamicFormAccordionModule, MatDynamicFormTabsModule];
/**
 * @deprecated Use {@link withMatDynamicFormElementDefaultFeatures} instead.
 */
class MatDynamicFormItemsModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormItemsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormItemsModule, imports: [MatDynamicFormAccordionModule, MatDynamicFormTabsModule], exports: [MatDynamicFormAccordionModule, MatDynamicFormTabsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormItemsModule, imports: [modules$3, MatDynamicFormAccordionModule, MatDynamicFormTabsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormItemsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$3,
                    exports: modules$3,
                }]
        }] });

class MatDynamicFormModalComponent extends DynamicFormModalBase {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalComponent, deps: null, target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormModalComponent, isStandalone: true, selector: "mat-dynamic-form-modal", usesInheritance: true, ngImport: i0, template: "@if (trigger) {\n  <dynamic-form-element [element]=\"trigger\" />\n}\n\n<mat-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n  (escaped)=\"element.close()\"\n/>\n", dependencies: [{ kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "component", type: MatDynamicFormDialogComponent, selector: "mat-dynamic-form-dialog", inputs: ["isOpen$", "children", "headerActions", "footerActions", "width", "height", "minWidth", "minHeight", "maxWidth", "maxHeight", "maximized", "title", "titleHtml", "classNameForm", "classNameModal", "classNameChildren", "classNameHeader", "classNameFooter", "classNameTitle"], outputs: ["escaped"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-modal', imports: [DynamicFormElementComponent, MatDynamicFormDialogComponent], template: "@if (trigger) {\n  <dynamic-form-element [element]=\"trigger\" />\n}\n\n<mat-dynamic-form-dialog\n  [isOpen$]=\"isOpen$\"\n  [children]=\"children\"\n  [headerActions]=\"headerActions\"\n  [footerActions]=\"footerActions\"\n  [width]=\"template.width\"\n  [height]=\"template.height\"\n  [minWidth]=\"template.minWidth\"\n  [minHeight]=\"template.minHeight\"\n  [maxWidth]=\"template.maxWidth\"\n  [maxHeight]=\"template.maxHeight\"\n  [maximized]=\"template.maximized\"\n  [title]=\"template.title\"\n  [titleHtml]=\"template.titleHtml\"\n  [classNameForm]=\"element.root.template.className\"\n  [classNameModal]=\"template.className\"\n  [classNameTitle]=\"template.classNameTitle\"\n  [classNameChildren]=\"template.classNameChildren\"\n  [classNameHeader]=\"template.classNameHeader\"\n  [classNameFooter]=\"template.classNameFooter\"\n  (escaped)=\"element.close()\"\n/>\n" }]
        }] });

const matDynamicFormModalType = {
    type: 'modal',
    factory: dynamicFormModalFactory,
    component: MatDynamicFormModalComponent,
    libraryName: matDynamicFormLibrary.name,
};
const modules$2 = [DynamicFormModalModule];
/**
 * @deprecated Use {@link withMatDynamicFormElementDefaultFeatures} instead.
 */
class MatDynamicFormModalModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalModule, imports: [DynamicFormModalModule], exports: [DynamicFormModalModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalModule, providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormModalType)), imports: [modules$2, DynamicFormModalModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormModalModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$2,
                    exports: modules$2,
                    providers: importDynamicFormsProviders(withDynamicFormElements(matDynamicFormModalType)),
                }]
        }] });

const matDynamicFormElementTypes = [matDynamicFormAccordionType, matDynamicFormTabsType, matDynamicFormModalType];
function withMatDynamicFormElementDefaultFeatures() {
    return [withDynamicFormElements(...matDynamicFormElementTypes), withDynamicFormModalActionHandlers()];
}
const modules$1 = [MatDynamicFormItemsModule, MatDynamicFormModalModule];
/**
 * @deprecated Use {@link withMatDynamicFormElementDefaultFeatures} instead.
 */
class MatDynamicFormElementModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormElementModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormElementModule, imports: [MatDynamicFormItemsModule, MatDynamicFormModalModule], exports: [MatDynamicFormItemsModule, MatDynamicFormModalModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormElementModule, imports: [modules$1, MatDynamicFormItemsModule, MatDynamicFormModalModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormElementModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules$1,
                    exports: modules$1,
                }]
        }] });

class MatDynamicFormInputWrapperComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputWrapperComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormInputWrapperComponent, isStandalone: true, selector: "mat-dynamic-form-input-wrapper", inputs: { label: "label", inputId: "inputId", required: "required", disabled: "disabled", invalid: "invalid", hasValidation: "hasValidation", errorMessage: "errorMessage" }, ngImport: i0, template: "<div\n  class=\"mat-mdc-form-field mat-mdc-form-field-wrapper\"\n  [ngClass]=\"{ 'mdc-text-field--disabled': disabled, 'mdc-text-field--invalid': invalid, 'no-validation': !hasValidation }\"\n>\n  <div class=\"mat-mdc-form-field-input-wrapper\">\n    @if (label) {\n      <label class=\"mat-mdc-form-field-input-label mat-mdc-floating-label mdc-floating-label\" [for]=\"inputId\"\n        >{{ label }}\n        @if (required) {\n          <span>*</span>\n        }\n      </label>\n    }\n    <ng-content />\n  </div>\n  @if (hasValidation) {\n    <div class=\"mat-mdc-form-field-subscript-wrapper mat-mdc-form-field-bottom-align\">\n      @if (invalid) {\n        <div class=\"mat-mdc-form-field-error-wrapper\">\n          <div class=\"mat-mdc-form-field-error mat-mdc-form-field-bottom-align\">{{ errorMessage }}</div>\n        </div>\n      }\n    </div>\n  }\n</div>\n", dependencies: [{ kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputWrapperComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-input-wrapper', imports: [NgClass], template: "<div\n  class=\"mat-mdc-form-field mat-mdc-form-field-wrapper\"\n  [ngClass]=\"{ 'mdc-text-field--disabled': disabled, 'mdc-text-field--invalid': invalid, 'no-validation': !hasValidation }\"\n>\n  <div class=\"mat-mdc-form-field-input-wrapper\">\n    @if (label) {\n      <label class=\"mat-mdc-form-field-input-label mat-mdc-floating-label mdc-floating-label\" [for]=\"inputId\"\n        >{{ label }}\n        @if (required) {\n          <span>*</span>\n        }\n      </label>\n    }\n    <ng-content />\n  </div>\n  @if (hasValidation) {\n    <div class=\"mat-mdc-form-field-subscript-wrapper mat-mdc-form-field-bottom-align\">\n      @if (invalid) {\n        <div class=\"mat-mdc-form-field-error-wrapper\">\n          <div class=\"mat-mdc-form-field-error mat-mdc-form-field-bottom-align\">{{ errorMessage }}</div>\n        </div>\n      }\n    </div>\n  }\n</div>\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], inputId: [{
                type: Input
            }], required: [{
                type: Input
            }], disabled: [{
                type: Input,
                args: [{ required: true }]
            }], invalid: [{
                type: Input,
                args: [{ required: true }]
            }], hasValidation: [{
                type: Input,
                args: [{ required: true }]
            }], errorMessage: [{
                type: Input
            }] } });

class MatDynamicFormCheckboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormCheckboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormCheckboxComponent, isStandalone: true, selector: "mat-dynamic-form-checkbox", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-checkbox\n    color=\"primary\"\n    [id]=\"inputId\"\n    [indeterminate]=\"input?.indeterminate\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    >{{ template.label }}\n    @if (validation?.required) {\n      <span>*</span>\n    }\n  </mat-checkbox>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "inputId", "required", "disabled", "invalid", "hasValidation", "errorMessage"] }, { kind: "ngmodule", type: MatCheckboxModule }, { kind: "component", type: i3$1.MatCheckbox, selector: "mat-checkbox", inputs: ["aria-label", "aria-labelledby", "aria-describedby", "id", "required", "labelPosition", "name", "value", "disableRipple", "tabIndex", "color", "disabledInteractive", "checked", "disabled", "indeterminate"], outputs: ["change", "indeterminateChange"], exportAs: ["matCheckbox"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormCheckboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-checkbox', imports: [ReactiveFormsModule, MatDynamicFormInputWrapperComponent, MatCheckboxModule], template: "<mat-dynamic-form-input-wrapper\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-checkbox\n    color=\"primary\"\n    [id]=\"inputId\"\n    [indeterminate]=\"input?.indeterminate\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n    >{{ template.label }}\n    @if (validation?.required) {\n      <span>*</span>\n    }\n  </mat-checkbox>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormCheckboxType = {
    type: 'checkbox',
    component: MatDynamicFormCheckboxComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormComboboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    ngOnInit() {
        this.filteredOptions = this.control.valueChanges.pipe(startWith(''), map(value => this.getFilteredOptions(value)));
    }
    getFilteredOptions(value) {
        const valueNormalized = value ? value.toUpperCase() : null;
        return valueNormalized ? this.input.options?.filter(option => option.toUpperCase().includes(valueNormalized)) : this.input.options;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormComboboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormComboboxComponent, isStandalone: true, selector: "mat-dynamic-form-combobox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    type=\"text\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [matAutocomplete]=\"auto\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-autocomplete #auto=\"matAutocomplete\">\n    @for (option of filteredOptions | async; track $index) {\n      <mat-option [value]=\"option\">{{ option }}</mat-option>\n    }\n  </mat-autocomplete>\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "pipe", type: AsyncPipe, name: "async" }, { kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatAutocompleteModule }, { kind: "component", type: i5.MatAutocomplete, selector: "mat-autocomplete", inputs: ["aria-label", "aria-labelledby", "displayWith", "autoActiveFirstOption", "autoSelectActiveOption", "requireSelection", "panelWidth", "disableRipple", "class", "hideSingleSelectionIndicator"], outputs: ["optionSelected", "opened", "closed", "optionActivated"], exportAs: ["matAutocomplete"] }, { kind: "component", type: i5$1.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "directive", type: i5.MatAutocompleteTrigger, selector: "input[matAutocomplete], textarea[matAutocomplete]", inputs: ["matAutocomplete", "matAutocompletePosition", "matAutocompleteConnectedTo", "autocomplete", "matAutocompleteDisabled"], exportAs: ["matAutocompleteTrigger"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormComboboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-combobox', imports: [AsyncPipe, ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatInputModule, MatAutocompleteModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    type=\"text\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [matAutocomplete]=\"auto\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-autocomplete #auto=\"matAutocomplete\">\n    @for (option of filteredOptions | async; track $index) {\n      <mat-option [value]=\"option\">{{ option }}</mat-option>\n    }\n  </mat-autocomplete>\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormComboboxType = {
    type: 'combobox',
    component: MatDynamicFormComboboxComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormDatepickerComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormDatepickerComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormDatepickerComponent, isStandalone: true, selector: "mat-dynamic-form-datepicker", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [matDatepicker]=\"datepicker\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [min]=\"validation?.minDate ? input.minDate : null\"\n    [max]=\"validation?.maxDate ? input.maxDate : null\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-datepicker-toggle matSuffix [for]=\"datepicker\" [disabled]=\"control.disabled || readonly\" />\n  <mat-datepicker #datepicker [disabled]=\"control.disabled\" />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "ngmodule", type: MatDatepickerModule }, { kind: "component", type: i5$2.MatDatepicker, selector: "mat-datepicker", exportAs: ["matDatepicker"] }, { kind: "directive", type: i5$2.MatDatepickerInput, selector: "input[matDatepicker]", inputs: ["matDatepicker", "min", "max", "matDatepickerFilter"], exportAs: ["matDatepickerInput"] }, { kind: "component", type: i5$2.MatDatepickerToggle, selector: "mat-datepicker-toggle", inputs: ["for", "tabIndex", "aria-label", "disabled", "disableRipple"], exportAs: ["matDatepickerToggle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormDatepickerComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-datepicker', imports: [ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatInputModule, MatDatepickerModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [matDatepicker]=\"datepicker\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [min]=\"validation?.minDate ? input.minDate : null\"\n    [max]=\"validation?.maxDate ? input.maxDate : null\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  <mat-datepicker-toggle matSuffix [for]=\"datepicker\" [disabled]=\"control.disabled || readonly\" />\n  <mat-datepicker #datepicker [disabled]=\"control.disabled\" />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormDatepickerType = {
    type: 'datepicker',
    component: MatDynamicFormDatepickerComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormFileComponent extends DynamicFormFileBase {
    constructor(builder, validationService) {
        super(builder, validationService);
        this.builder = builder;
        this.validationService = validationService;
    }
    ngOnInit() {
        super.ngOnInit();
        this._matInput.ngControl = this._ngControl;
        this._matInput['_errorStateTracker'].ngControl = this._ngControl;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormFileComponent, deps: [{ token: i1$1.DynamicFormBuilder }, { token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormFileComponent, isStandalone: true, selector: "mat-dynamic-form-file", viewQueries: [{ propertyName: "_matInput", first: true, predicate: MatInput, descendants: true, static: true }, { propertyName: "_ngControl", first: true, predicate: NgControl, descendants: true, static: true }], usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    readonly\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n  />\n  <input\n    #fileDirective=\"dynamicFormFile\"\n    fileControl\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  <dynamic-form-element matSuffix [element]=\"uploadAction\" />\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "directive", type: DynamicFormFileDirective, selector: "[dynamicFormFile]", inputs: ["acceptFiles", "multipleFiles"], exportAs: ["dynamicFormFile"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatFormFieldModule }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormFileComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-file', imports: [ReactiveFormsModule, DynamicFormFileDirective, DynamicFormElementComponent, MatInputModule, MatFormFieldModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\" [class.suffixes-flex]=\"suffixAddOn\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    readonly\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [value]=\"fileDirective.fileNamesAsText || ''\"\n    [disabled]=\"control.disabled\"\n    (blur)=\"control.markAsTouched()\"\n  />\n  <input\n    #fileDirective=\"dynamicFormFile\"\n    fileControl\n    dynamicFormFile\n    [acceptFiles]=\"input.accept\"\n    [multipleFiles]=\"input.multiple\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  <dynamic-form-element matSuffix [element]=\"uploadAction\" />\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormBuilder }, { type: i1$1.DynamicFormValidationService }], propDecorators: { _matInput: [{
                type: ViewChild,
                args: [MatInput, { static: true }]
            }], _ngControl: [{
                type: ViewChild,
                args: [NgControl, { static: true }]
            }] } });

const matDynamicFormFileType = {
    type: 'file',
    component: MatDynamicFormFileComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormNumberboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormNumberboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormNumberboxComponent, isStandalone: true, selector: "mat-dynamic-form-numberbox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    type=\"number\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NumberValueAccessor, selector: "input[type=number][formControlName],input[type=number][formControl],input[type=number][ngModel]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormNumberboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-numberbox', imports: [ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatInputModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    type=\"number\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormNumberboxType = {
    type: 'numberbox',
    component: MatDynamicFormNumberboxComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormRadioComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormRadioComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormRadioComponent, isStandalone: true, selector: "mat-dynamic-form-radio", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-radio-group [formControl]=\"control\">\n    @for (option of input.options; let index = $index; track index) {\n      <mat-radio-button color=\"primary\" [id]=\"inputId + '-' + index\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-radio-button>\n    }\n  </mat-radio-group>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "inputId", "required", "disabled", "invalid", "hasValidation", "errorMessage"] }, { kind: "ngmodule", type: MatRadioModule }, { kind: "directive", type: i3$3.MatRadioGroup, selector: "mat-radio-group", inputs: ["color", "name", "labelPosition", "value", "selected", "disabled", "required", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioGroup"] }, { kind: "component", type: i3$3.MatRadioButton, selector: "mat-radio-button", inputs: ["id", "name", "aria-label", "aria-labelledby", "aria-describedby", "disableRipple", "tabIndex", "checked", "value", "labelPosition", "disabled", "required", "color", "disabledInteractive"], outputs: ["change"], exportAs: ["matRadioButton"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormRadioComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-radio', imports: [ReactiveFormsModule, MatDynamicFormInputWrapperComponent, MatRadioModule], template: "<mat-dynamic-form-input-wrapper\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-radio-group [formControl]=\"control\">\n    @for (option of input.options; let index = $index; track index) {\n      <mat-radio-button color=\"primary\" [id]=\"inputId + '-' + index\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-radio-button>\n    }\n  </mat-radio-group>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormRadioType = {
    type: 'radio',
    component: MatDynamicFormRadioComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormSelectComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormSelectComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormSelectComponent, isStandalone: true, selector: "mat-dynamic-form-select", usesInheritance: true, ngImport: i0, template: "@if (input.multiple) {\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select multiple [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n      @for (option of input.options; track option) {\n        @if (option.items) {\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            @for (optionItem of option.items; track optionItem) {\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            }\n          </mat-optgroup>\n        } @else {\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        }\n      }\n    </mat-select>\n    @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n    }\n    @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n    }\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n} @else {\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n      @for (option of input.options; track option) {\n        @if (option.items) {\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            @for (optionItem of option.items; track optionItem) {\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            }\n          </mat-optgroup>\n        } @else {\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        }\n      }\n    </mat-select>\n    @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n    }\n    @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n    }\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n}\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatSelectModule }, { kind: "component", type: i4$2.MatSelect, selector: "mat-select", inputs: ["aria-describedby", "panelClass", "disabled", "disableRipple", "tabIndex", "hideSingleSelectionIndicator", "placeholder", "required", "multiple", "disableOptionCentering", "compareWith", "value", "aria-label", "aria-labelledby", "errorStateMatcher", "typeaheadDebounceInterval", "sortComparator", "id", "panelWidth"], outputs: ["openedChange", "opened", "closed", "selectionChange", "valueChange"], exportAs: ["matSelect"] }, { kind: "component", type: i5$1.MatOption, selector: "mat-option", inputs: ["value", "id", "disabled"], outputs: ["onSelectionChange"], exportAs: ["matOption"] }, { kind: "component", type: i5$1.MatOptgroup, selector: "mat-optgroup", inputs: ["label", "disabled"], exportAs: ["matOptgroup"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormSelectComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-select', imports: [ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatSelectModule], template: "@if (input.multiple) {\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select multiple [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n      @for (option of input.options; track option) {\n        @if (option.items) {\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            @for (optionItem of option.items; track optionItem) {\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            }\n          </mat-optgroup>\n        } @else {\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        }\n      }\n    </mat-select>\n    @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n    }\n    @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n    }\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n} @else {\n  <mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n    <mat-label>{{ template.label }}</mat-label>\n    <mat-select [id]=\"inputId\" [placeholder]=\"input.placeholder\" [required]=\"validation?.required\" [formControl]=\"control\">\n      @for (option of input.options; track option) {\n        @if (option.items) {\n          <mat-optgroup [label]=\"option.label\" [disabled]=\"option.disabled\">\n            @for (optionItem of option.items; track optionItem) {\n              <mat-option [value]=\"optionItem.value\" [disabled]=\"optionItem.disabled\">{{ optionItem.label }}</mat-option>\n            }\n          </mat-optgroup>\n        } @else {\n          <mat-option [value]=\"option.value\" [disabled]=\"option.disabled\">{{ option.label }}</mat-option>\n        }\n      }\n    </mat-select>\n    @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n      <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n    }\n    @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n    }\n    @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n      <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n    }\n    <mat-hint [align]=\"'start'\">{{ hints?.hintStart }}</mat-hint>\n    <mat-hint [align]=\"'end'\">{{ hints?.hintEnd }}</mat-hint>\n    <mat-error>{{ errorMessage }}</mat-error>\n  </mat-form-field>\n}\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormSelectType = {
    type: 'select',
    component: MatDynamicFormSelectComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormSwitchComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormSwitchComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormSwitchComponent, isStandalone: true, selector: "mat-dynamic-form-switch", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-slide-toggle color=\"primary\" [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\"\n    >{{ template.label }}\n    @if (validation?.required) {\n      <span>*</span>\n    }\n  </mat-slide-toggle>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "inputId", "required", "disabled", "invalid", "hasValidation", "errorMessage"] }, { kind: "ngmodule", type: MatSlideToggleModule }, { kind: "component", type: i3$4.MatSlideToggle, selector: "mat-slide-toggle", inputs: ["name", "id", "labelPosition", "aria-label", "aria-labelledby", "aria-describedby", "required", "color", "disabled", "disableRipple", "tabIndex", "checked", "hideIcon", "disabledInteractive"], outputs: ["change", "toggleChange"], exportAs: ["matSlideToggle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormSwitchComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-switch', imports: [ReactiveFormsModule, MatDynamicFormInputWrapperComponent, MatSlideToggleModule], template: "<mat-dynamic-form-input-wrapper\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-slide-toggle color=\"primary\" [id]=\"inputId\" [required]=\"validation?.required\" [formControl]=\"control\"\n    >{{ template.label }}\n    @if (validation?.required) {\n      <span>*</span>\n    }\n  </mat-slide-toggle>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormSwitchType = {
    type: 'switch',
    component: MatDynamicFormSwitchComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormTextareaComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTextareaComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormTextareaComponent, isStandalone: true, selector: "mat-dynamic-form-textarea", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <textarea\n    #autosize=\"cdkTextareaAutosize\"\n    matInput\n    cdkTextareaAutosize\n    cdkAutosizeMinRows=\"1\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  >\n  </textarea>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "directive", type: i5$3.CdkTextareaAutosize, selector: "textarea[cdkTextareaAutosize]", inputs: ["cdkAutosizeMinRows", "cdkAutosizeMaxRows", "cdkTextareaAutosize", "placeholder"], exportAs: ["cdkTextareaAutosize"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTextareaComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-textarea', imports: [ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatInputModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <textarea\n    #autosize=\"cdkTextareaAutosize\"\n    matInput\n    cdkTextareaAutosize\n    cdkAutosizeMinRows=\"1\"\n    [id]=\"inputId\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  >\n  </textarea>\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormTextareaType = {
    type: 'textarea',
    component: MatDynamicFormTextareaComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormTextboxComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTextboxComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormTextboxComponent, isStandalone: true, selector: "mat-dynamic-form-textbox", usesInheritance: true, ngImport: i0, template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: DynamicFormElementComponent, selector: "dynamic-form-element" }, { kind: "ngmodule", type: MatFormFieldModule }, { kind: "component", type: i3$2.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i3$2.MatLabel, selector: "mat-label" }, { kind: "directive", type: i3$2.MatHint, selector: "mat-hint", inputs: ["align", "id"] }, { kind: "directive", type: i3$2.MatError, selector: "mat-error, [matError]", inputs: ["id"] }, { kind: "directive", type: i3$2.MatPrefix, selector: "[matPrefix], [matIconPrefix], [matTextPrefix]", inputs: ["matTextPrefix"] }, { kind: "directive", type: i3$2.MatSuffix, selector: "[matSuffix], [matIconSuffix], [matTextSuffix]", inputs: ["matTextSuffix"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4$1.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormTextboxComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-textbox', imports: [ReactiveFormsModule, DynamicFormElementComponent, MatFormFieldModule, MatInputModule], template: "<mat-form-field appearance=\"fill\" color=\"primary\" [floatLabel]=\"template.labelFloating\">\n  <mat-label>{{ template.label }}</mat-label>\n  <input\n    matInput\n    [id]=\"inputId\"\n    [type]=\"input.inputTypeForced || input.inputType\"\n    [placeholder]=\"input.placeholder\"\n    [readonly]=\"readonly\"\n    [required]=\"validation?.required\"\n    [formControl]=\"control\"\n  />\n  @if (prefixAddOn?.classType === \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matTextPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (prefixAddOn && prefixAddOn.classType !== \"element\" && !prefixAddOn.hidden) {\n    <dynamic-form-element matPrefix [element]=\"prefixAddOn\" />\n  }\n  @if (suffixAddOn?.classType === \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matTextSuffix [element]=\"suffixAddOn\" />\n  }\n  @if (suffixAddOn && suffixAddOn.classType !== \"element\" && !suffixAddOn.hidden) {\n    <dynamic-form-element matSuffix [element]=\"suffixAddOn\" />\n  }\n  <mat-hint align=\"start\">{{ hints?.hintStart }}</mat-hint>\n  <mat-hint align=\"end\">{{ hints?.hintEnd }}</mat-hint>\n  <mat-error>{{ errorMessage }}</mat-error>\n</mat-form-field>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormTextboxType = {
    type: 'textbox',
    component: MatDynamicFormTextboxComponent,
    libraryName: matDynamicFormLibrary.name,
};

class MatDynamicFormToggleComponent extends DynamicFormInputBase {
    constructor(validationService) {
        super(validationService);
        this.validationService = validationService;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormToggleComponent, deps: [{ token: i1$1.DynamicFormValidationService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "18.2.6", type: MatDynamicFormToggleComponent, isStandalone: true, selector: "mat-dynamic-form-toggle", usesInheritance: true, ngImport: i0, template: "<mat-dynamic-form-input-wrapper\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-button-toggle-group [formControl]=\"control\">\n    @for (option of input.options; let index = $index; track index) {\n      <mat-button-toggle [id]=\"inputId + '-' + index\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-button-toggle>\n    }\n  </mat-button-toggle-group>\n</mat-dynamic-form-input-wrapper>\n", dependencies: [{ kind: "ngmodule", type: ReactiveFormsModule }, { kind: "directive", type: i2$1.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2$1.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: MatDynamicFormInputWrapperComponent, selector: "mat-dynamic-form-input-wrapper", inputs: ["label", "inputId", "required", "disabled", "invalid", "hasValidation", "errorMessage"] }, { kind: "ngmodule", type: MatButtonToggleModule }, { kind: "directive", type: i3$5.MatButtonToggleGroup, selector: "mat-button-toggle-group", inputs: ["appearance", "name", "vertical", "value", "multiple", "disabled", "disabledInteractive", "hideSingleSelectionIndicator", "hideMultipleSelectionIndicator"], outputs: ["valueChange", "change"], exportAs: ["matButtonToggleGroup"] }, { kind: "component", type: i3$5.MatButtonToggle, selector: "mat-button-toggle", inputs: ["aria-label", "aria-labelledby", "id", "name", "value", "tabIndex", "disableRipple", "appearance", "checked", "disabled", "disabledInteractive"], outputs: ["change"], exportAs: ["matButtonToggle"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormToggleComponent, decorators: [{
            type: Component,
            args: [{ standalone: true, selector: 'mat-dynamic-form-toggle', imports: [ReactiveFormsModule, MatDynamicFormInputWrapperComponent, MatButtonToggleModule], template: "<mat-dynamic-form-input-wrapper\n  [inputId]=\"inputId\"\n  [label]=\"template.label\"\n  [required]=\"validation?.required\"\n  [disabled]=\"disabled\"\n  [invalid]=\"showErrors\"\n  [hasValidation]=\"hasValidation\"\n  [errorMessage]=\"showErrors ? errorMessage : null\"\n>\n  <mat-button-toggle-group [formControl]=\"control\">\n    @for (option of input.options; let index = $index; track index) {\n      <mat-button-toggle [id]=\"inputId + '-' + index\" [value]=\"option.value\" [disabled]=\"option.disabled\">{{\n        option.label\n      }}</mat-button-toggle>\n    }\n  </mat-button-toggle-group>\n</mat-dynamic-form-input-wrapper>\n" }]
        }], ctorParameters: () => [{ type: i1$1.DynamicFormValidationService }] });

const matDynamicFormToggleType = {
    type: 'toggle',
    component: MatDynamicFormToggleComponent,
    libraryName: matDynamicFormLibrary.name,
};

const matDynamicFormInputTypes = [
    matDynamicFormCheckboxType,
    matDynamicFormComboboxType,
    matDynamicFormDatepickerType,
    matDynamicFormFileType,
    matDynamicFormNumberboxType,
    matDynamicFormRadioType,
    matDynamicFormSelectType,
    matDynamicFormSwitchType,
    matDynamicFormTextareaType,
    matDynamicFormTextboxType,
    matDynamicFormToggleType,
];
const matDynamicFormFieldDefaultOptions = { floatLabel: 'always' };
function withMatDynamicFormFieldDefaultOptions(options = matDynamicFormFieldDefaultOptions) {
    return { providers: [{ provide: MAT_FORM_FIELD_DEFAULT_OPTIONS, useValue: options }] };
}
function withMatDynamicFormInputDefaultFeatures(options = matDynamicFormFieldDefaultOptions) {
    return [
        withDynamicFormInputs(...matDynamicFormInputTypes),
        withDynamicFormTextboxActionHandlers(),
        withDynamicFormFileValidators(),
        withMatDynamicFormFieldDefaultOptions(options),
    ];
}
const modules = [DynamicFormFileModule, DynamicFormTextboxModule];
/**
 * @deprecated Use {@link withMatDynamicFormInputDefaultFeatures} instead.
 */
class MatDynamicFormInputModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputModule, imports: [DynamicFormFileModule, DynamicFormTextboxModule], exports: [DynamicFormFileModule, DynamicFormTextboxModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputModule, providers: importDynamicFormsProviders(withDynamicFormInputs(...matDynamicFormInputTypes), withMatDynamicFormFieldDefaultOptions()), imports: [modules, DynamicFormFileModule, DynamicFormTextboxModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormInputModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: modules,
                    exports: modules,
                    providers: importDynamicFormsProviders(withDynamicFormInputs(...matDynamicFormInputTypes), withMatDynamicFormFieldDefaultOptions()),
                }]
        }] });

function provideMatDynamicForms(...features) {
    return [provideDynamicForms(matDynamicFormLibrary, ...features)];
}
const matDynamicFormValidationConfig = {
    aliases: {
        matDatepickerMin: 'minDate',
        matDatepickerMax: 'maxDate',
    },
    libraryName: matDynamicFormLibrary.name,
};
const matDynamicFormsDefaultFeatures = [
    ...withDynamicFormValidationDefaults(matDynamicFormValidationConfig),
    ...withMatDynamicFormActionDefaultFeatures(),
    ...withMatDynamicFormElementDefaultFeatures(),
    ...withMatDynamicFormInputDefaultFeatures(),
];
function getDynamicFormsFeatures(config) {
    const features = [];
    if (config?.theme) {
        features.push(withDynamicFormsTheme(config?.theme));
    }
    if (config?.idBuilder) {
        features.push(withDynamicFormsIdBuilder(config?.idBuilder));
    }
    return features;
}
function provideMatDynamicFormsWithDefaultFeatures(config, ...additionalFeatures) {
    const features = [...matDynamicFormsDefaultFeatures, ...getDynamicFormsFeatures(config), ...additionalFeatures];
    return provideDynamicFormsWithDefaultFeatures(matDynamicFormLibrary, ...features);
}
/**
 * @deprecated Use {@link provideMatDynamicFormsWithDefaultFeatures} instead.
 */
class MatDynamicFormsModule {
    /**
     * @deprecated Use {@link provideMatDynamicFormsWithDefaultFeatures} instead.
     */
    static forRoot(config, ...additionalFeatures) {
        const features = [withDynamicFormsLibrary(matDynamicFormLibrary), ...getDynamicFormsFeatures(config), ...additionalFeatures];
        return { ngModule: MatDynamicFormsModule, providers: importDynamicFormsProviders(...features) };
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormsModule, imports: [DynamicFormsModule], exports: [DynamicFormsModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormsModule, providers: provideDynamicFormsWithDefaultFeatures(null, ...matDynamicFormsDefaultFeatures, withDynamicFormValidation()), imports: [DynamicFormsModule, DynamicFormsModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: MatDynamicFormsModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [DynamicFormsModule],
                    exports: [DynamicFormsModule],
                    providers: provideDynamicFormsWithDefaultFeatures(null, ...matDynamicFormsDefaultFeatures, withDynamicFormValidation()),
                }]
        }] });

class DatetimeAdapter extends DateAdapter {
}
class NativeDatetimeAdapter extends NativeDateAdapter {
    getHours(date) {
        return date.getHours();
    }
    getMinutes(date) {
        return date.getMinutes();
    }
    getSeconds(date) {
        return date.getSeconds();
    }
    compareDate(first, second) {
        return (this.getYear(first) - this.getYear(second) ||
            this.getMonth(first) - this.getMonth(second) ||
            this.getDate(first) - this.getDate(second) ||
            this.getHours(first) - this.getHours(second) ||
            this.getMinutes(first) - this.getMinutes(second) ||
            this.getSeconds(first) - this.getSeconds(second));
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: NativeDatetimeAdapter, deps: null, target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: NativeDatetimeAdapter }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "18.2.6", ngImport: i0, type: NativeDatetimeAdapter, decorators: [{
            type: Injectable
        }] });
function provideNativeDatetimeAdapter() {
    return [{ provide: DatetimeAdapter, useClass: NativeDatetimeAdapter }];
}

/*
 * Public API Surface of material
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DatetimeAdapter, MatDynamicFormAccordionComponent, MatDynamicFormAccordionModule, MatDynamicFormActionModule, MatDynamicFormButtonComponent, MatDynamicFormCheckboxComponent, MatDynamicFormComboboxComponent, MatDynamicFormDatepickerComponent, MatDynamicFormDialogComponent, MatDynamicFormElementModule, MatDynamicFormFileComponent, MatDynamicFormIconComponent, MatDynamicFormInputModule, MatDynamicFormItemsModule, MatDynamicFormModalComponent, MatDynamicFormModalModule, MatDynamicFormNumberboxComponent, MatDynamicFormRadioComponent, MatDynamicFormSelectComponent, MatDynamicFormTabsComponent, MatDynamicFormTabsModule, MatDynamicFormTextareaComponent, MatDynamicFormTextboxComponent, MatDynamicFormsModule, NativeDatetimeAdapter, matDynamicFormAccordionType, matDynamicFormActionTypes, matDynamicFormButtonType, matDynamicFormCheckboxType, matDynamicFormComboboxType, matDynamicFormDatepickerType, matDynamicFormElementTypes, matDynamicFormFieldDefaultOptions, matDynamicFormFileType, matDynamicFormIconType, matDynamicFormInputTypes, matDynamicFormLibrary, matDynamicFormModalType, matDynamicFormNumberboxType, matDynamicFormRadioType, matDynamicFormSelectType, matDynamicFormTabsType, matDynamicFormTextareaType, matDynamicFormTextboxType, matDynamicFormValidationConfig, matDynamicFormsDefaultFeatures, provideMatDynamicForms, provideMatDynamicFormsWithDefaultFeatures, provideNativeDatetimeAdapter, withMatDynamicFormActionDefaultFeatures, withMatDynamicFormElementDefaultFeatures, withMatDynamicFormFieldDefaultOptions, withMatDynamicFormInputDefaultFeatures };
//# sourceMappingURL=dynamic-forms-material.mjs.map
