import { Provider } from '@angular/core';
import { DateAdapter, NativeDateAdapter } from '@angular/material/core';
import * as i0 from "@angular/core";
export declare abstract class DatetimeAdapter<TDatetime, TLocale = any> extends DateAdapter<TDatetime, TLocale> {
    abstract getHours(date: TDatetime): number;
    abstract getMinutes(date: TDatetime): number;
    abstract getSeconds(date: TDatetime): number;
}
export declare class NativeDatetimeAdapter extends NativeDateAdapter implements DatetimeAdapter<Date> {
    getHours(date: Date): number;
    getMinutes(date: Date): number;
    getSeconds(date: Date): number;
    compareDate(first: Date, second: Date): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<NativeDatetimeAdapter, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<NativeDatetimeAdapter>;
}
export declare function provideNativeDatetimeAdapter(): Provider[];
